//Fclass.cc
//
// example class
//
// copyright 1998, by Thomas Weldon,
// allrights reserved
//
//
// Students in eegr6118 may make copies and modify them 
//for the purposes of their course  projects during spring 1996.
//Any other use of this file is prohibited.
//


#include "Fclass.h"
#include "fft.cc"

//   
//    BASIC *******************************************
//   


Fclass::Fclass()			//default constructor
{
	Fxdim = 2;
	Fydim = 2;
 	Re = new float[4];		//why not
 	Im = new float[4];		//why not
	Fname = new  char[strlen("unnamed")+10];
	strcpy(Fname,"unnamed");
}

//    Function: Fclass::Fclass(int x, int y)  
//    		partial constructor, allocates memory, name="unnamed"
//    		Example: Fclass a(2,2);
Fclass::Fclass(int x, int y)  //partial constructor
{
	set_new_handler(newerr);
if( (x<1) || (y<1) ) // null array
	{
	cout << "null array assignment in Fclass::Fclass(int x, int y)  \n";
	cout << " x=" << x<< " y=" <<y <<"\n";
	exit(1);
	}
else	{
	
	Fxdim = x;
	Fydim = y;
	Re = new float[x * y];
	Im = new float[x * y];
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{*(Re + xx * Fydim + yy) = 0;
		*(Im + xx * Fydim + yy) = 0;
		}
	Fname = new  char[strlen("unnamed")+1];
	strcpy(Fname,"unnamed");
	}
}


//    
//    Function: Fclass::Fclass(const Fclass& im) 
//    		copy constructor
//    		Example: Fclass a(b);
Fclass::Fclass(Fclass &im)  //copy constructor
{
	set_new_handler(newerr);


if( (im.Fxdim <=  0) || (im.Fydim <= 0) || 
		(im.Fname == ( char *) 0) ||
	 	(im.Re ==  (float *) 0)   ||
	 	(im.Im ==  (float *) 0) ) // null array
	{
	cout << "null  assignment in Fclass::Fclass(Fclass& im)  \n";
	cout << " im.Fxdim=" << im.Fxdim<< " im.ydim=" 
	<<im.Fydim << " im.Re=" <<im.Re <<"\n";
	exit(1);
	}
else	{

	Fxdim = im.Fxdim;
	Fydim = im.Fydim;
	Re = new float[Fxdim*Fydim];
	Im = new float[Fxdim*Fydim];
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(Re + xx * Fydim + yy)= *(im.Re + xx * Fydim + yy);
		 *(Im + xx * Fydim + yy)= *(im.Im + xx * Fydim + yy);
		}
	Fname = new char[strlen(im.name())+1];
	strcpy(Fname,im.name());
	}
}
	

//    
//    Function: Fclass::~Fclass()	
//    		destructor, delete [] Re;delete Fname;
Fclass::~Fclass()				//destructor
{
	if ( (Re == (float *) 0 ) || (Fname == (char *) 0 ) )
		{cout << "--- warning ~Fclass() of null array\n";}
	delete Re;
	delete Im;
	delete Fname;
} 


//   
//    GET DATA FROM OBJECT *******************************************
//   

//    
//    Function: float Fclass::getelre(int x, int y)
//    		returns real value of element x,y in Fclass
//    		Example: i.getelre(1,1);
float Fclass::getelre(int x, int y)
{
 if ( (x >= 0) && (x < Fxdim) && (y >= 0) && (y < Fydim))
 	return *(Re + x * Fydim + y);
 else
	{cout << "access element Fclass::getelre(int x, int y)" << x << "," 
	<< y << " out of range in Re " << Fname << "\n"; exit(1);}
}

//    
//    Function: float Fclass::getelre(int x, int y)
//    		returns imaginary value of element x,y in Fclass
//    		Example: i.getelim(1,1);
float Fclass::getelim(int x, int y)
{
 if ( (x >= 0) && (x < Fxdim) && (y >= 0) && (y < Fydim))
 	return *(Im + x * Fydim + y);
 else
	{cout << "access element Fclass::getelim(int x, int y)" << x << "," 
	<< y << " out of range in Im " << Fname << "\n"; exit(1);}
}


//    
//    LOAD DATA INTO OBJECT ************************************************
//    

//    
//    Function:  void Fclass::setelre(int x, int y, float c)
//    		sets real value of element x,y in Fclass to c
//    
void Fclass::setelre(int x, int y, float c)
{
 if ( (x >= 0) && (x < Fxdim) && (y >= 0) && (y < Fydim))
 	*(Re + x * Fydim + y)=c;
 else
	{cout << "access element Fclass::setelre(int x, int y, float c)" << x << "," 
	<< y << " out of range in Re " << Fname << "\n"; exit(1);}
}


//    
//    Function:  void Fclass::setelim(int x, int y, float c)
//    		sets imaginary value of element x,y in Fclass to c
//    
void Fclass::setelim(int x, int y, float c)
{
 if ( (x >= 0) && (x < Fxdim) && (y >= 0) && (y < Fydim))
 	*(Im + x * Fydim + y)=c;
 else
	{cout << "access element Fclass::setelim(int x, int y, float c)" << x << "," 
	<< y << " out of range in Im " << Fname << "\n"; exit(1);}
}

//    
//    IO ************************************************
//    


//    
//    Functions ************************************************
//    



//    
//    Function: Fclass&  Fclass::operator=(Fclass& im)
//    		overloaded equals operator:
//		not very sophisticated
//    
Fclass&  Fclass::operator=(Fclass& im)
{
	set_new_handler(newerr);


if( (im.Fxdim ==  0) || (im.Fydim == 0) ||
	(im.name() ==  ( char *) 0) || 
	(im.Re ==  (float *) 0)|| 
	(im.Im ==  (float *) 0)  ) // null array
	{
	cout << "null array assignment in Fclass::operator= \n";
	cout << " im.Fxdim=" << im.Fxdim<< " im.Fydim=" 
	<<im.Fydim << " im.Re=" <<im.Re << " im.Im=" <<im.Im <<"\n";
	exit(1);
	}
else
	{
	Fxdim = im.Fxdim ;
	Fydim = im.Fydim  ;
	if(Re != (float *) 0) delete  Re;
	Re = new float[Fxdim*Fydim];
	if(Im != (float *) 0) delete  Im;
	Im = new float[Fxdim*Fydim];
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(Re + xx * Fydim + yy)= *(im.Re + xx * Fydim + yy);
		 *(Im + xx * Fydim + yy)= *(im.Im + xx * Fydim + yy);
		}
	return *this;
	}

}




//    
//    Function: Fclass&  Fclass::operator=(Fclass& im)
//    		overloaded equals operator:
//		not very sophisticated
//    
Fclass&  Fclass::operator=(Iclass& im)
{
	set_new_handler(newerr);

if( (im.getxdim() ==  0) || (im.getydim() == 0) ||
	(im.name() ==  ( char *) 0) || 
	(im.getiarray() ==  (unsigned char *) 0) 
	  ) // null array
	{
	cout << "null array assignment in Fclass::operator= \n";
	cout << " im.getxdim()=" << im.getxdim()<< " im.getydim()=" 
	<<im.getydim() << " im.getiarray()=" <<im.getiarray()   <<"\n";
	exit(1);
	}
else
	{
	Fxdim = im.getxdim() ;
	Fydim = im.getydim()  ;
	if(Re != (float *) 0) delete  Re;
	Re = new float[Fxdim*Fydim];
	if(Im != (float *) 0) delete  Im;
	Im = new float[Fxdim*Fydim];
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(Re + xx * Fydim + yy)= *(im.getiarray() + xx * Fydim + yy);
		 *(Im + xx * Fydim + yy)= 0;
		}
	if(Fname != (char *) 0) delete Fname;
	Fname = new  char[strlen(im.name())+1];
	strcpy(Fname,im.name());
	return *this;
	}

}


//    
//    Function: void Fclass::cvtimg(Iclass & im)
//    		writes real contents into image
//		not very sophisticated
//    
void Fclass::cvtimg(Iclass & im)
{
	set_new_handler(newerr);

if( (im.getxdim() ==  0) || (im.getydim() == 0) ||
	(im.name() ==  ( char *) 0) || 
	(im.getiarray() ==  (unsigned char *) 0) 
	 || (  im.getxdim() != Fxdim  )  
	 || (  im.getydim() != Fydim  )  
	) // null array
	{
	cout << "null array assignment in Fclass::cvtimg \n";
	cout << " im.getxdim()=" << im.getxdim()<< " im.getydim()=" 
	<<im.getydim() << " im.getiarray()=" << (float *)im.getiarray() <<"\n"
	<< "Fxdim="<<Fxdim<<" Fydim="<<Fydim<<" im.name()="<< im.name() <<"\n";
	exit(1);
	}
else
	{
	int xx,yy;
	float max,min,z;
	max=(*this).getelre(0,0);
	min=(*this).getelre(0,0);
	
	for ( xx = 0; xx < Fxdim; xx++)
		for ( yy = 0; yy < Fydim ; yy++)
		{
		if (max< *(Re + xx * Fydim + yy)) 
			max=*(Re + xx * Fydim + yy);
		if (min> *(Re + xx * Fydim + yy)) 
			min=*(Re + xx * Fydim + yy);
		}
	cout <<"max="<<max<<"min="<<min<<"\n";

	if (max==min) min=max-1;
	for ( xx = 0; xx < Fxdim; xx++)
		for ( yy = 0; yy < Fydim ; yy++)
		{
		z=*(Re + xx * Fydim + yy);
		z= 255 *(z-min)/(max-min);
		im.setel(xx,yy, (int)z);
		}

	}

}



//    
//    Function: Fclass  Fclass::operator+(int x)
//    		add int value to all Fclass elements
//
Fclass  Fclass::operator+(int x)
{
if( (Fxdim ==  0) || (Fydim == 0) || 
		(Re== (float *) 0) ) // null array

	{
	cout << "null array assignment in Fclass::operator+(int x) \n";
	exit(1);
	}

else	
	{
	float cx=(float ) x;
	Fclass im = *this;
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		 *(im.Re + xx * im.Fydim + yy)
		=  *(Re + xx * Fydim + yy)+cx;
	return im;
	}
}


//    
//    Function: Fclass  Fclass::operator+(Fclass& x)
//
Fclass  Fclass::operator+(Fclass& x)
{
if( (Fxdim ==  0) || (Fydim == 0) || (Re== ( float *) 0) ||
		(x.Fxdim ==  0) || (x.Fydim == 0) ||
		 (x.Re== ( float *) 0) ) // null array
	{
	cout << "null array assignment in Fclass::operator+(Fclass& x) \n";
	exit(1);
	}
else
if( (Fxdim ==  x.Fxdim) && (Fydim == x.Fydim) )  //same size array
	{
	Fclass im = *this;
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(im.Re + xx * im.Fydim + yy)= 
		*(Re + xx * Fydim + yy) +(*(x.Re + xx * x.Fydim + yy));
		 *(im.Im + xx * im.Fydim + yy)= 
		*(Im + xx * Fydim + yy) +(*(x.Im + xx * x.Fydim + yy));
		}
	if (Fname != (char *) 0) delete Fname;
	Fname = new char[strlen("unamed")+1];
	strcpy(Fname,"unamed");
	return im;
	}
else 
	{
	cout << "error dropthrough all tests in Fclass::operator+(Fclass x) \n";
	exit(1);
	}
}





//    
//    Function: Fclass  Fclass::operator*(Fclass& x)
//
Fclass  Fclass::operator*(Fclass& x)
{
if( (Fxdim ==  0) || (Fydim == 0) || (Re== ( float *) 0) ||
		(x.Fxdim ==  0) || (x.Fydim == 0) ||
		 (x.Re== ( float *) 0) ) // null array
	{
	cout << "null array assignment in Fclass::operator+(Fclass& x) \n";
	exit(1);
	}
else
if( (Fxdim ==  x.Fxdim) && (Fydim == x.Fydim) )  //same size array
	{
	Fclass im = *this;
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(im.Re + xx * im.Fydim + yy)= 
		*(Re + xx * Fydim + yy) * (*(x.Re + xx * x.Fydim + yy))-
		*(Im + xx * Fydim + yy) * (*(x.Im + xx * x.Fydim + yy));
		 *(im.Im + xx * im.Fydim + yy)= 
		*(Re + xx * Fydim + yy) *(*(x.Im + xx * x.Fydim + yy))+
		*(Im + xx * Fydim + yy) *(*(x.Re + xx * x.Fydim + yy));
		}
	if (Fname != (char *) 0) delete Fname;
	Fname = new char[strlen("unamed")+1];
	strcpy(Fname,"unamed");
	return im;
	}
else 
	{
	cout << "error dropthrough all tests in Fclass::operator+(Fclass x) \n";
	exit(1);
	}
}



