// fft.cc
//
//  
// copyright 1998, by Thomas Weldon,
// allrights reserved
//
//
//
// Students in eegr6118 may make copies and modify them 
//for the purposes of their course  projects during spring 1996.
//Any other use of this file is prohibited.
//
// a VERY rough draft FFT for 2-D images
// to be loaded into Fclass.cc
//

Fclass Fclass::fft()
{


	if ( (*this).Fxdim <= 0)
		{
		cout << "error n <= 0 in " << 
		"Fclass::fftoned()\n" <<
		"n="<<(float)Fxdim<<"\n";
		exit(1);
		}

 	int xx,yy;

	Fclass im=(*this);

	Fclass row( im.Fxdim , 1);

	for ( xx = 0; xx < im.Fxdim; xx++)
	{
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		row.setelre(yy,0, im.getelre(yy,xx) );
		row.setelim(yy,0, im.getelim(yy,xx) );
		}
	row=row.fftoned();
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		im.setelre(yy,xx, row.getelre(yy,0) );
		im.setelim(yy,xx, row.getelim(yy,0) );
		}
	}
 	im=im.transpose();
 	for ( xx = 0; xx < im.Fxdim; xx++)
	{
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		row.setelre(yy,0, im.getelre(yy,xx) );
		row.setelim(yy,0, im.getelim(yy,xx) );
		}
	row=row.fftoned();
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		im.setelre(yy,xx, row.getelre(yy,0) );
		im.setelim(yy,xx, row.getelim(yy,0) );
		}
	}
	im=im.transpose();

	return im;

}


Fclass Fclass::ifft()
{

	if ( (*this).Fxdim <= 0)
		{
		cout << "error n <= 0 in " << 
		"Fclass::fftoned()\n" <<
		"n="<<(float)Fxdim<<"\n";
		exit(1);
		}

 	int xx,yy;

	Fclass im=(*this);

	Fclass row( im.Fxdim , 1);

	for ( xx = 0; xx < im.Fxdim; xx++)
	{
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		row.setelre(yy,0, im.getelre(yy,xx) );
		row.setelim(yy,0, im.getelim(yy,xx) );
		}
	row=row.ifftoned();
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		im.setelre(yy,xx, row.getelre(yy,0) );
		im.setelim(yy,xx, row.getelim(yy,0) );
		}
	}
 
	im=im.transpose();
  
	for ( xx = 0; xx < im.Fxdim; xx++)
	{
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		row.setelre(yy,0, im.getelre(yy,xx) );
		row.setelim(yy,0, im.getelim(yy,xx) );
		}
	row=row.ifftoned();
	for ( yy= 0; yy < im.Fydim; yy++)
		{ 
		im.setelre(yy,xx, row.getelre(yy,0) );
		im.setelim(yy,xx, row.getelim(yy,0) );
		}
	}
	im=im.transpose();

	return im;

}

Fclass Fclass::transpose()
{
	Fclass im = *this;
	im.Fxdim=Fydim;
	im.Fydim=Fxdim;
	for (int xx = 0; xx < Fxdim; xx++)
		for (int yy = 0; yy < Fydim ; yy++)
		{
		 *(im.Re + yy * im.Fydim + xx)= 
		*(Re + xx * Fydim + yy) ;
		 *(im.Im + yy * im.Fydim + xx)= 
		*(Im + xx * Fydim + yy) ;
		}
 	return im;

}


Fclass Fclass::fftoned()
{

	if ( (*this).Fxdim <= 0)
		{
		cout << "error n <= 0 in " << 
		"Fclass::fftoned()\n" <<
		"n="<<(float) Fxdim <<"\n";
		exit(1);
		}

	Fclass t1;

	t1=(*this);
		t1=t1.fftoned2(0);
		return t1;

}


Fclass Fclass::ifftoned()
{

	Fclass t1;

	t1=(*this);

		t1=t1.fftoned2(1);
		return t1;

}



//
// 	1-D FFT routine
// 	
// 	assumes xdimension is power of 2, ydimension=1
//

Fclass Fclass::fftoned2(int inv)		//inverse if inv !=0
{

				//copyright 1995, Thomas Weldon,
				//allrights reserved


	if ( ( (*this).Fxdim <= 0 ) || ( (*this).Fydim != 1 )  )
		{
		cout << "error n <= 0 in " << 
		"Fclass::fftoned2()\n" <<
		"n="<<(float) Fxdim <<"\n";
		exit(1);
		}

	int prime=2;			//prime factor of this routine
	int N= (*this).Fxdim;				//fftoned size
	int maxpow=20;			//max size=prime^maxpower
	int pown;			//actual power; N=prime^pown
	double pi=3.141592654;
	int a,b,i1,i2,flag;		//dummy vars
	int nn,kk,arg;			//more dummies
	int mask1,mask2;		//bit reversal mask
	int fwd,rev;			//fwd and bit reverse
	int rr,offset;			//buterfly level
	Fclass w0( *this );		// array of all possible angles
//	Fclass wk( *this );		// array particular twiddle factors 
	float topsumre,topsumim,botsumre,botsumim;	// butter dummies
	float topre,topim,botre,botim;		    //butter dummies
	int groups,gcnt,gsize,butcnt,numbut,kn;		//butter dummies
	Fclass t1;

	N= (*this).Fxdim;
	t1=(*this);

	
	
	i1=1; flag=1; pown=0;		//first check for power of prime
	for ( a=0; a < maxpow; a++)
		{
		i1=i1*prime;
		if (i1==N) 
			{flag=0; pown=a+1;}
		}

	if ( flag != 0 )
		{
		cout << "error size not power of "<<prime<<
		" or bigger than  " << pow(prime,(maxpow)) <<
		"Fclass::fftoned2()\n" <<
		"n="<<(float) Fxdim <<"\n";
		exit(1);
		}

//	fprintf(stderr,"fftoned2: N= %d, pown= %d  \n",N,pown);


						//reorder data
	for (a=0; a < N ; a++)
		{
		fwd=a;
		rev=0;
		mask1=1;
		mask2=N>>1;
		if (mask1 & fwd) rev=rev | mask2;
		for (b=2; b<=pown; b++)
			{
			mask2=  mask2 >> 1;
			mask1=  mask1 << 1;
			if (mask1 & fwd) rev=rev | mask2;
			}

		if ( (rev >= Fxdim) || (rev < 0) )
			{
			cout << "error bad index bit reverse in " <<
			"Fclass::fftoned2()\n" <<
			"rev="<<(float) rev <<"\n";
			exit(1);
			}
		else
			{
			*(t1.Re + a) = *( (*this).Re + rev);
			*(t1.Im + a) = *( (*this).Im + rev);
			}
		}


//**** level 0 butterflies **********************

	rr=0; 	//first level is just additions
	groups=N/(2<<rr);	//number of butterfly groups
	numbut= 1 << rr;	//number of butterflies in group
	offset= numbut;		//offset between top and bot of one but
	gsize=2*offset;		//size of a group of butterflies
	


	for ( gcnt=0; gcnt < groups; gcnt++ ) 
		{
						//buterfly inputs
		i1=gcnt * gsize ;	//index of top of but
		i2=gcnt * gsize +offset;//index of bot of but
		topre=*(t1.Re + i1 );	
		topim=*(t1.Im + i1 ) ;
		botre=*(t1.Re + i2 ) ;
		botim=*(t1.Im + i2 );

		topsumre=topre + botre;		//butterfly outputs
		topsumim=topim + botim;
		botsumre=topre - botre;
		botsumim=topim - botim;

		*(t1.Re + i1)=topsumre;		//save result in place
		*(t1.Im + i1)=topsumim;
		*(t1.Re + i2)=botsumre;
		*(t1.Im + i2)=botsumim;

		}
	
	kk=1;				//create all possible angles (W0)

	if (inv != 1)	//forward transform
	   	{
	   	for ( nn=0; nn < N ; nn++ )
			{
			arg = (nn * kk) % N;
			*( w0.Re + nn) = cos ( (-2.0 * pi * arg) / N);
			*( w0.Im + nn) = sin ( (-2.0 * pi * arg) / N);
			}
	   	}

	else		//inverse transform
	   	{
	   	for ( nn=0; nn < N ; nn++ )
			{
			arg = (nn * kk) % N;
			*( w0.Re + nn) = cos ( (2.0 * pi * arg) / N);
			*( w0.Im + nn) = sin ( (2.0 * pi * arg) / N);
			}
	   	}



//**** upper level  butterflies **********************


	for (rr=1; rr<pown ; rr++)	//subsequent levels
		{
		groups=N/(2<<rr);	//number of butterfly groups
		numbut= 1 << rr;	//number of butterflies in group
		offset= numbut;		//offset between top and bot of one but
		gsize=2*offset;		//size of a group of butterflies
	
					//gcnt counts which group
					//butsiz counts butterflies in group

		for ( gcnt=0; gcnt < groups; gcnt++ ) 
		for ( butcnt=0; butcnt<numbut; butcnt++)
			{
			kn=(groups * butcnt) ;
							//buterfly inputs
			i1=gcnt * gsize +butcnt;	//index of top of but
			i2=gcnt * gsize +butcnt +offset;//index of bot of but

			topre=*(t1.Re + i1 );	
			topim=*(t1.Im + i1 ) ;
			botre=*(t1.Re + i2 ) * ( *( w0.Re + kn) )
				- *(t1.Im + i2 ) * ( *( w0.Im + kn) );
			botim=*(t1.Re + i2 ) *  ( *( w0.Im + kn) )+
				( *( w0.Re + kn) ) * *(t1.Im + i2 );

			topsumre=topre + botre;		//butterfly outputs
			topsumim=topim + botim;
			botsumre=topre - botre;
			botsumim=topim - botim;

			*(t1.Re + i1)=topsumre;		//save result in place
			*(t1.Im + i1)=topsumim;
			*(t1.Re + i2)=botsumre;
			*(t1.Im + i2)=botsumim;
			}


		}	
	


	if (inv != 1)	//forward transform
	   	{
		return t1;
		}
	else
		{

		for (a=0; a < N ; a++)
			{
			*(t1.Re + a) = *(t1.Re + a)/N;
			*(t1.Im + a) = *(t1.Im + a)/N;
			}
		
		return t1;
		}
}




